module TimeKeeper
  module Parser
    class Military < Base
      TIME_FORMAT_REGEX = /^((\d){1}|(\d){2})((:(\d){2}){1})?$/

      validates :time_str, :presence => true, :format => {:with => TimeKeeper::Parser::Military::TIME_FORMAT_REGEX}

      def parse
        matched_data = @time_str.match(TimeKeeper::Parser::Military::TIME_FORMAT_REGEX)
        extract_hour(matched_data[1])
        extract_min(matched_data[4])
        self
      end

      private

      def time_is_valid
        matched_data = @time_str.match(TimeKeeper::Parser::Military::TIME_FORMAT_REGEX)
        valid = ((0...24) === matched_data[1].to_i && (0...60) === matched_data[4].gsub(':', '').to_i)
        self.errors.add(:base, "Either hour or min is not valid") unless valid
        valid
      end

      def extract_hour(hour_of_day)
        @hour = (hour_of_day.strip.to_i || 0)
      end
    end
  end
end