module TimeKeeper
  module StringMinutesSupport
    def to_s_helper(minutes)
      return nil if minutes.nil?
      h = minutes.to_i / 60
      m = minutes.to_i % 60
      "%.2d:%.2d" % [h,m]
    end

    def to_i_helper(time)
      return nil if time.blank?
      time = time.to_s
      h,m = time.split(":")
      m ||= "0"
      raise ArgumentError, "#{time.inspect} is invalid" unless h =~ /^\d+$/ && m =~ /^\d+$/
      (h.to_i*60) + m.to_i
    end
  end
end
