module TimeKeeper
  module TimeRangeManipulation
    def split_time_range_by_day(range)
      return [] if range.blank?
      if range.first.to_date < range.last.to_date
        out = []
        current = range.first
        while current.to_i <= range.last.to_i
          eod = current.end_of_day
          eod = range.last if current.to_date == range.last.to_date
          out << (current .. eod)
          current = eod + 1.second
        end
        out
      else
        [range]
      end
    end
    module_function :split_time_range_by_day
  end
end